#include <stdio.h>
#include <stdlib.h>

#define BLlength 4

  unsigned char *buffer;
  unsigned char *Value;

int main(int argc, char **argv)
{
  FILE *fp;

  int ind;
  char *Fname;
  long lSize;

  size_t result;

  int Nblocks;

  if (argc!=2) {fputs ("enter file name\n", stderr); exit(0);}

  Fname = argv[1];

  fp = fopen (Fname, "rb");
  if (fp==NULL) {fputs ("File error", stderr); exit (1);}

  /* obtain file size */

  fseek (fp , 0 , SEEK_END);
  lSize = ftell (fp);
  rewind (fp);

  /* allocate memory to contain one event */

  buffer = (unsigned char*) malloc(sizeof(unsigned char)*BLlength);

  if (buffer==NULL) {fputs ("Memory error", stderr); exit (2);}

/* Loop over the entire data sample */

  Nblocks = lSize/BLlength;  // integer division to cut off corrupted tail !!!

  for (ind=0; ind<Nblocks; ind++)
    {
      int i, MBA;

      int Nevent, Nevt[4];

/* copy the data portion into the buffer */

     result = fread (buffer, 1, BLlength, fp);
     if (result != BLlength) {fputs ("Reading error", stderr); exit (3);}

/* set pointer to the beginning of data field */

     Value = buffer;

/* Global event number - needed when the local event number
is not available (motherboard readout causes time out) */

     Nevt[0] = (int)*Value++;
     Nevt[1] = (int)*Value++;     
     Nevt[2] = (int)*Value++;     
     Nevt[3] = (int)*Value++;

     Nevent = Nevt[3]<<24 | Nevt[2]<<16 | Nevt[1]<<8 | Nevt[0];

     printf("%d\n", Nevent);

    } /* end for(Nblocks) */

  fclose (fp);
  free (buffer);
  return 0;
}
